import time
import pygame
import sys
import siot
import requests

pygame.init()

def draw_jd(x, y, value, tips):
    pygame.draw.rect(screen, (value * 255 / 100, 255 - value * 255 / 100, 0), (x, y - (value * 3), 150, (value * 3)))
    pygame.draw.rect(screen, (0, 0, 0), (x, y - 300, 150, 300), 3)
    text = font_40.render(str(value) + "%", True, (0, 0, 0))
    screen.blit(text, (x + 154, y - 44))
    text = font_20.render(str(tips), True, (0, 0, 0))
    screen.blit(text, (x + 30, y + 70))


def draw_jd_heng(x, y, now_day, day_limit):
    global first_list 
    pygame.draw.rect(screen, (255, 255, 255), (x, y, 150, 50))
    if int(first_list[1]) == 0:
        value = 0
        last_days = "∞"
    elif int(first_list[1]) >= 90:
        value = 100
        last_days = 0
    else:
        if now_day <= day_limit:
            value = (now_day / day_limit) * 100
            last_days = int(day_limit - now_day)
        else:
            value = 100
            last_days = 0
    pygame.draw.rect(screen, (0, 0, 0), (x, y, int(value * 1.5), 20))
    pygame.draw.rect(screen, (0, 0, 0), (x, y, 150, 20), 3)
    text = font_20.render("剩余提醒天数:" + str(last_days), True, (0, 0, 0))
    screen.blit(text, (x, y + 25))


def get_current_time():
    current_time = time.strftime('%Y-%m-%d %H:%M:%S', time.localtime())
    return current_time
    

def on_message_callback(client, userdata, msg):
    global clean
    global count_clean_time
    global listen_start_time
    global first_list
    print(msg.payload.decode())
    screen.fill((255, 255, 255))
    first_list = msg.payload.decode().split("a")
    first_list[1] = int(float(first_list[1])) * 5
    if float(first_list[1]) < 0:
        first_list[1] = 0
    elif float(first_list[1]) > 100:
        first_list[1] = 100
    else:
        first_list[1] = int(float(first_list[1]))


clean = False
last_clean_condition = False
count_clean_time = False
listen_start_time = 999999999999999999999999
screen = pygame.display.set_mode((500, 500))
first_list = ["->", 0, 0]
pygame.display.set_caption("社区公益回收箱智能化系统  管理端")

siot.init(client_id="",server="iot.dfrobot.com.cn",port=1883,user="BALABALA",password="BALABALA")
siot.connect()
siot.loop()
siot.set_callback(on_message_callback)
siot.getsubscribe(topic="6vOUlhmIR")
screen.fill((255, 255, 255))
pygame.display.flip()
locked_wet = 0
day_limit = 60

font_20 = pygame.font.Font("C:\\Windows\\Fonts\\simhei.ttf", 20)
font_30 = pygame.font.Font("C:\\Windows\\Fonts\\simhei.ttf", 30)
font_40 = pygame.font.Font("C:\\Windows\\Fonts\\simhei.ttf", 40)

while True:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            sys.exit()
    screen.fill((255, 255, 255))

    if int(first_list[1]) > 0 and int(first_list[1]) < 90 and count_clean_time == False:
        listen_start_time = time.time()
        count_clean_time = True
    if time.time() - listen_start_time >= day_limit:
        clean = True
    if int(first_list[1]) >= 90:
        clean = True
    if int(first_list[1]) == 0:
        clean = False
        count_clean_time = False
    if clean == True:
        text = font_30.render("1号需要清理，请尽快处理！", True, (255, 0, 0))
        screen.blit(text, (70, 45))
    

    if int(first_list[2]) > locked_wet:
        locked_wet = int(first_list[2])
    if locked_wet >= 50:
        day_limit = 90 - int(locked_wet / 1.5) - (int(float(first_list[1])) / 5)
    else:
        day_limit = 60 - (int(float(first_list[1])) / 5)
    
    if int(first_list[1]) == 0:
        locked_wet = 0
    # print(locked_wet)
    draw_jd_heng(175, 410, (time.time() - listen_start_time), day_limit)
    draw_jd(175, 400, int(first_list[1]), "1号回收箱")
    text = font_20.render("湿度：" + str(first_list[2]) + "%rh", True, (0, 0, 0))
    screen.blit(text, (195, 78))
    pygame.display.flip()

    if last_clean_condition == False and clean == True:
        req_msg = 'http://trim.wyylkjs.top/rccb/progress?msg=        <tr><td><span style="color: %23007bff;">'+get_current_time()+'</td><td></td><td><span style="color: %23ee0000;">已提醒工作人员处理</span></td></tr>'
        requests.get(req_msg)
    elif last_clean_condition == True and clean == False:
        pass

    last_clean_condition = clean

    time.sleep(0.1)
